/**
 * Type conversion
 *
 */
public class TypeConversions {

    public static void main(String[] args) {
        doBoxingUnBoxing();
        //doAutomaticTypeConversion();
        //doExplicitTypeConversion();
    }

    public static void doBoxingUnBoxing() {
        Integer i = 123;  // Primitiv till referens
        int j = i;          // Referens till primitiv
    }

    // Solution below
    public static void doAutomaticTypeConversion(){
         System.out.println(1 + 1);
        System.out.println("1" + "1");
        System.out.println(1.0 + 1.0);

        System.out.println(1 + "1");
        System.out.println(1.0 + "1");
        System.out.println("1" + Math.PI);
        System.out.println('1' + 1);
        System.out.println(1 + new Integer(1));
        System.out.println(new Integer(1) + new Double(1.0));
        System.out.println(1 + 2 + " mammals");
        System.out.println("mammals " + 1 + 2);
    }

    public static void doExplicitTypeConversion() {
        String s = Integer.toString(123);
        Integer i = Integer.valueOf("123");
        int j  = Integer.valueOf("123");
        s = i.toString();
    }

}




/*  Solution ----------------------------------------------------------------------
         + operator works for many types (overloaded)
        System.out.println(1 + 1);  // + as integer arithmetic 
        System.out.println("1" + "1");// + as string concatenation
        System.out.println(1.0 + 1.0);  // + as floating point arithmetic 

        System.out.println(1 + "1");  // String conversion, then concatenation
        System.out.println(1.0 + "1");  // String conversion, then concatenation
        System.out.println("1" + Math.PI);  // String conversion, then concatenation
        System.out.println('1' + 1); // Char to integer, then integer arithmetic
        System.out.println(1 + new Integer(1)); //Unboxing, then integer arithmetic
        System.out.println(new Integer(1) + new Double(1.0));  // Unboxing, then to double, floating point arithmetic performed
        System.out.println(1 + 2 + " mammals"); // Integer arithmetic, string conversion, then concatenation
        System.out.println("mammals " + 1 + 2); // String conversion, then concatenation

 */